package polish_community_group_11.polish_community.admin.services;

import org.springframework.stereotype.Service;
import polish_community_group_11.polish_community.admin.dao.AdminRepository;
import polish_community_group_11.polish_community.admin.models.AdminBoard;
import polish_community_group_11.polish_community.admin.models.ManageUser;

import java.sql.SQLException;
import java.util.List;

@Service
public class AdminServiceImpl implements AdminService {
    private final AdminRepository adminRepository;

    public AdminServiceImpl(AdminRepository adminRepository) {
        this.adminRepository = adminRepository;
    }
    public List<ManageUser> getUserManagementInfo() throws SQLException {
        return adminRepository.getUserManagementInfo();
    }
    public AdminBoard getBoardManagementInfo() throws SQLException{
        return adminRepository.getBoardManagementInfo();
    }

    public void updateUserRole(ManageUser user, String roleName){
        boolean needsUpdate=roleName.toLowerCase().equals(user.getRole().toLowerCase())?
                false:true;
        if(needsUpdate){
            int updatedRoleId=roleName.toLowerCase().equals("admin")?1:2;
            user.setRole_id(updatedRoleId);
            adminRepository.updateUserRole(user);
        }
    }

    public void deleteUser(int userId){
        adminRepository.deleteUser(userId);
    }
}
